
/* 1. Описати своїми словами навіщо потрібні функції у програмуванні.
   
  Если нам нужно выполнить одноитпные расчеты в разных местах кода, но с разными входными данными, то мы эти расчеты можем обернуть в функцию, и передавать в нее разные аргументы. 
  После этого мы можем вызвать эту функцию в любом месте кода сколько угодно раз, и единожды написанные расчеты будут выполнятся для разных условий, сколько угодно раз. 
*/

/*  2. Описати своїми словами, навіщо у функцію передавати аргумент.
 
   Когда мы передаем в функцию аргументы она использует их в качестве параметров при выполнении кода. 
   Мы можем не передавать в функцию аргумнты, тогда есть 2 варианта работы таких функций: 
      1) Можно создать переменные внутри фуекции, присвоить им какие-то значения, на оснвании этих значений выполнить вычисления и вернуть результат.
         Такая функция не будет менять внешние переменные, и не будет универсальной и переиспользуемой, и не будет подстраиваться под изменение внешних данных.
      2) Функция может подстраиваться под изменение внешних данных, но тогда для вычислений нужно использовать внешние переменные. 
         Но использовать и менять внешние переменные это плохо т.к. если переменные поменяют название не рабочей.
   Поэтому, лучшим вариантом использования функций будет передать в нее аргументы, которые функция будет использовать в качестве входных данных, 
   и при этом будет универсальной, и не будет зависеть от названия внешних переменных - это называется "чистой" функцией. 
*/

/*  3. Що таке оператор return та як він працює всередині функції?

   Смысл вызова функции заключается в том, что после ее выполнения мы ожидаем получить результат ее работы, но мы не узнаем этот результат если функция не вернет нам его с помощью команды return (результатом будет undefined).
   Такое поведение допустимо лишь когда мы не передаем в функцию аргументы и она меняет внешние данные, но это плохая практика. В других случаях если функция ничего не возвращает ее запуск будет бессмысленным.
   После использования кючевого слова return функция прекращает дольнейшее выполнение кода и возвращает результат который можно будет использовать за пределами этой функции.   
   
*/

let num_1 = setNumber(`Введіть перше число`, 25);
let num_2 = setNumber(`Введіть друге число`, 10);
let operator = prompt(`Введіть один з наступних операторів: " + " або " - " або " * " або " / "`, "+");

console.log(calc(num_1, num_2, operator));


function setNumber(text, value) {
   let num = prompt(text, value);
   while (isNaN(num) || !num) {
      alert(`Ви ввели не корректні данні або не ввели данні. Повторіть ввід знову!`);
      num = prompt(text, value);
   }
   return num;
}

function calc(num1, num2, operator) {
   switch (operator) {
      case "+":
         return +num1 + +num2;
      case "-":
         return +num1 - +num2;
      case "*":
         return +num1 * +num2;
      case "/":
         return +num1 / +num2;
      default:
         alert(`Програма не може виконати цю операцію`);
   };
};